default:
    image: registry.gitlab.com/lavcorps-line/infrastructure/alpine-dockers/3.17:stable

workflow:
    rules:
        -
            when: always

stages:
    - build
    - deploy

compile module:
    stage: build
    script:
        - |
            printf "\n${COLOR_F_MAGENTA_D}Initializing...${COLOR_F_DEFAULT}\n"
            sudo apk add jq zip
            mkdir -p artifacts
        - |
            printf "\n${COLOR_F_MAGENTA_D}Operating...${COLOR_F_DEFAULT}\n"
            printf "\n${COLOR_F_MAGENTA_D}Patching Version...${COLOR_F_DEFAULT}\n"
            tmp=$(mktemp)
            if [ -n "$CI_COMMIT_TAG" ]; then
                jq --arg tag "$CI_COMMIT_TAG" '.version = $tag' module.json > "$tmp"
            elif [ -n "$CI_COMMIT_SHORT_SHA" ]; then
                jq --arg sha "0.0.0-$CI_COMMIT_SHORT_SHA" '.version = $sha' module.json > "$tmp"
            else
                jq --arg ver "0.0.0" '.version = $ver' module.json > "$tmp"
            fi
            mv -v "$tmp" module.json
            printf "\n${COLOR_F_MAGENTA_D}Patching URL...${COLOR_F_DEFAULT}\n"
            tmp=$(mktemp)
            jq --arg url "${CI_PROJECT_URL}" '.url = $url' module.json > "$tmp"
            mv -v "$tmp" module.json
            printf "\n${COLOR_F_MAGENTA_D}Patching Manifest Link...${COLOR_F_DEFAULT}\n"
            tmp=$(mktemp)
            jq --arg url "${CI_PROJECT_URL}/-/releases/permalink/latest/downloads/module.json" '.manifest = $url' module.json > "$tmp"
            mv -v "$tmp" module.json
            printf "\n${COLOR_F_MAGENTA_D}Patching Download Link...${COLOR_F_DEFAULT}\n"
            tmp=$(mktemp)
            jq --arg url "${CI_PROJECT_URL}/-/releases/permalink/latest/downloads/module.zip" '.download = $url' module.json > "$tmp"
            mv -v "$tmp" module.json
            printf "\n${COLOR_F_MAGENTA_D}Packaging...${COLOR_F_DEFAULT}\n"
            tmp=$(mktemp)
            jq --tab '.' module.json | sed 's/\t/    /g' > "$tmp"
            mv -v "$tmp" module.json
            chmod -v 0644 module.json
            cp -v module.json artifacts/module.json
            zip -r artifacts/module.zip module.json README.md LICENSE styles/ scripts/ templates/ languages/
            chmod -v 0644 artifacts/module.zip artifacts/module.json
            printf "\n${COLOR_F_MAGENTA_D}Complete!${COLOR_F_DEFAULT}\n"
    artifacts:
        paths:
            - artifacts/
        expire_in: 1 hour

upload module:
    needs: ["compile module"]
    stage: build
    image: curlimages/curl:latest
    script:
        - |
            printf "\n${COLOR_F_MAGENTA_D}Uploading assets...${COLOR_F_DEFAULT}\n"
            curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file "artifacts/module.json" "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/${CI_PROJECT_PATH_SLUG}/${CI_COMMIT_TAG}/module.json"
            curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file "artifacts/module.zip" "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/${CI_PROJECT_PATH_SLUG}/${CI_COMMIT_TAG}/module.zip"
    rules:
        -
            if: '$CI_COMMIT_TAG'

release module:
    needs: ["upload module"]
    stage: deploy
    image: registry.gitlab.com/gitlab-org/release-cli:latest
    script:
        - |
            printf "\n${COLOR_F_MAGENTA_D}Hello World!${COLOR_F_DEFAULT}\n"
    rules:
        -
            if: '$CI_COMMIT_TAG'
    release:
        tag_name: '$CI_COMMIT_TAG'
        description: '$CI_COMMIT_TAG_MESSAGE'
        assets:
            links:
                -
                    name: 'module.json'
                    url: '${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/${CI_PROJECT_PATH_SLUG}/${CI_COMMIT_TAG}/module.json'
                    filepath: '/module.json'
                    link_type: 'other'
                -
                    name: 'module.zip'
                    url: '${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/${CI_PROJECT_PATH_SLUG}/${CI_COMMIT_TAG}/module.zip'
                    filepath: '/module.zip'
                    link_type: 'other'